import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Puck here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class puck extends Actor
{
private int pucksize = 50;
private int puckrad = pucksize/2;
private int padrad = 75/2;
private int boundrySize;
private int boardHeight;
private int boardWidth;
private int speed = 10;
private int collideDistance = puckrad + padrad;
private static GreenfootSound boundrySound = new GreenfootSound("hit.wav");
private static GreenfootSound scoreSound = new GreenfootSound("score.wav");
private static GreenfootSound paddleSound = new GreenfootSound("hit.wav");

    /**
     * Act - do whatever the Puck wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    
    {
        int direction;
        boolean bounced = false;
        boolean aGoal;
        boolean aPaddleHit = false;
        direction = getRotation();
        
        
        aGoal = inGoal();
        if(aGoal == false)
        {
            //check for paddle hit.
            if(paddleHit() == true)
            {
                paddleSound.play();
                aPaddleHit = true;
            }
        }
        if(atTop() == true)
        {
            //System.out.println("In at top x==" + getX() + "y==" + getY() + "dir==" + direction);
            if((direction >= 250) && (direction < 290))
            {
                //This stops the puck from goin up and down.
                
                direction = direction+20;
               
            }
            setRotation(360 - direction); 
            bounced = true;
        }
        
        
        else if(atBottom() == true)
        { 
            //System.out.println("In at bottom x==" + getX() + "y==" + getY() + "dir==" + direction);
            if((direction > 85) || (direction < 95))
            {
                //This stops the puck from goin up and down.
                //direction = direction-5;
            }
            setRotation(360 - direction);
            bounced = true;
        }
        direction = getRotation();
        if(atLeft() == true)
        {
            //System.out.println("In at left x==" + getX() + "y==" + getY() + "dir==" + direction);
            setRotation(180 - direction);
            bounced = true;
        }
        direction = getRotation();
        if (atRight() == true)
        {
            //System.out.println("In at right x==" + getX() + "y==" + getY() + "dir==" + direction);
            setRotation(180 - direction);
            bounced = true;
        }
        
        fixOutofBounds();
        //System.out.println("Out of beforemove left x ==" + getX());
        if(aPaddleHit == true)
        {
            rotAfterPaddle();
        }
        
        
        if(paddleHit() == true)
        {
            move(speed);
        }
        //System.out.println("Out of aftermove left x ==" + getX() + "'y==" + getRotation() );
        if(bounced == true)
        {
         speed--;
         if(speed<=5)
         {
             speed = 5;
         }
         boundrySound.play();
        }
        if(aPaddleHit == true)
        {
            speed+=5;
            if(speed>=15)
            {
                speed=15;
            }
        }
        
        
        //System.out.println("x==" + getX() + " y==" + getY() + " rotation==" + getRotation());
        if(aGoal == true)
        {
            scoreSound.play();
            getWorld().removeObject(this);
        }
        
        
        
        move(speed);
       
    }  
    
    public puck(int boardHeight, int boardWidth, int boundrySize, int initdir)
    {
        this.boardHeight = boardHeight;
        this.boardWidth = boardWidth;
        this.boundrySize = boundrySize;
        setRotation(initdir);
    }
    
   private boolean atTop()
   {
       if(getY() <= (boundrySize + puckrad))
       {
           return true;
       }
       else
       {
           return false;
       }
   }
   
   private boolean atBottom()
   {
       if(getY() >= (boardHeight - boundrySize - puckrad))
       {
           return true;
       }
       else
       {
           return false;
       }
   }
   
   private boolean atLeft()
   {
       if(getX() <= (boundrySize + puckrad))
       {
           //System.out.println(" true In at left x ==" + getX());
           return true;
       }
       else
       {
           //System.out.println(" false In at left x ==" + getX());
           return false;
       }
   }
   
   private boolean atRight()
   {
       if(getX() >= (boardWidth - boundrySize - puckrad))
       {
           return true;
       }
       else
       {
           return false;
       }
   }
   
   private boolean inGoal()
   {
     Actor actor;
     Goal goal;
     actor = getOneIntersectingObject(Goal.class);
     if(actor != null)
     {
         //System.out.println("puck in goal x == " + getX());
         goal = (Goal) actor;
         goal.goalMade();
         return true;
     }
     return false;
   }
   
   private boolean paddleHit()
   {
     paddle curpaddle;
     double curdist;
     
     curpaddle = (paddle)getOneIntersectingObject(paddle.class);
     if(curpaddle != null)
     {
         curdist = Math.sqrt((double)((curpaddle.getX()-this.getX())*(curpaddle.getX()-this.getX()))
                                                                +
                             (double)((curpaddle.getY()-this.getY())*(curpaddle.getY()-this.getY())));
         if((int)curdist <= collideDistance)
         {
             return true;
         }
         else
         {
             return false;
         }
         
     }
     
     return false;
   }
   
   private void rotAfterPaddle()
   {
     int angle;
     int newRotation;
     paddle curpaddle;
     
     curpaddle = (paddle)getOneIntersectingObject(paddle.class);
     if(curpaddle != null)
     {
         //System.out.println("puck in goal x == " + getX());
         angle = Angle(this.getX(), this.getY(), curpaddle.getX(), curpaddle.getY());
         newRotation = newDirection(getRotation(), angle);
         //System.out.println("angle ==" +angle);
         //System.out.println("newRoation =="  +newRotation);
         //System.out.println("oldRoation =="  +getRotation());
         setRotation(newRotation);
     }
   }
   
   private void fixOutofBounds()
   {
       //fix out of bounds left.
       
       if(getX() <= boundrySize + puckrad)
       {
           //System.out.println("before set Out of bounds left x ==" + getX());
           setLocation(boundrySize + puckrad + 1, getY()); 
           //System.out.println("after set Out of bounds left x ==" + getX());
       }
       //fix out of bound right.
       
        if(getX() >= (boardWidth - (boundrySize + puckrad)))
       {
           //System.out.println("before set Out of bounds left x ==" + getX());
           setLocation(boardWidth - (boundrySize + puckrad + 1), getY()); 
           //System.out.println("after set Out of bounds left x ==" + getX());
       }
       
       //fix out of bounds up.
       
       if(getY() <= boundrySize + puckrad)
       {
           //System.out.println("before set Out of bounds left Y ==" + getY());
           setLocation(getX(), boundrySize + puckrad + 1) ; 
           //System.out.println("after set Out of bounds left y ==" + getY());
       }
       
       //fix out of bound right.
       
        if(getY() >= (boardHeight - (boundrySize + puckrad)))
       {
           //System.out.println("before set Out of bounds left y ==" + getY());
           setLocation(getX(), boardHeight - (boundrySize + puckrad + 1)); 
           //System.out.println("after set Out of bounds left Y ==" + getY());
       }
   }
   
    private final static double Rad2Deg = 180.0 / Math.PI;
    
    private static int Angle(double x1, double y1, double x2, double y2)
    {
        int returnAngle;
        
        returnAngle = (int) (Math.atan2(y2 - y1, x2-x1) * Rad2Deg);
        if(returnAngle < 0)
        {
            returnAngle += 360;
        }
        return(returnAngle);
    }
    
    private static int newDirection(int oldDirection, int collideAngle)
    {
        int deflectangle;
        int newangle;
        
        //determine the change in direction
        //make sure it is between 0 and 359
        deflectangle = ((collideAngle +360) - oldDirection) *2;
        //make sure positive
        //modify the direct by the change and reverse it
        newangle = 180 + oldDirection + deflectangle;
        return(newangle % 360);
    }
   
   
   
}
