import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Color;
import java.util.List;

/**
 * Write a description of class Board here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Board extends World
{
    private int worldWidth = 1040;
    private int worldHeight = 580;
    private int boundrySize = 30;
    private int g = 150;
    private Goal rightgoal;
    private Goal leftgoal;
    /**
     * Constructor for objects of class Board.
     * 
     */
    public Board()
    {    
        super(1040, 580, 1); 

        prepare();
    }
    
    public void act()
    {
        puck ourpuck;
        List puckList;
        List introList;
        List score;
        List inst;
        
        
        puckList = getObjects(puck.class);
        introList = getObjects(IntroScreen.class);
        score = getObjectsAt(540, 300, Score.class);
        inst = getObjectsAt(540, 300, Instructions.class);
        if(puckList.isEmpty())
        {
            g++;
        }
        if(puckList.isEmpty() && introList.isEmpty() && score.isEmpty()== true && g > 150 && inst.isEmpty()==true && Greenfoot.isKeyDown("space"))
        {
             g=0;
             if(Greenfoot.getRandomNumber(2)==0)
             {
                 ourpuck = new puck(worldHeight, worldWidth, boundrySize, 0);
             }
             else
             {
                 ourpuck = new puck(worldHeight, worldWidth, boundrySize, 180);
             }
             addObject(ourpuck, worldWidth/2, worldHeight/2);
        }
        if(puckList.isEmpty() && score.isEmpty()== true && Greenfoot.isKeyDown("r"))
        {
            List<Goal> goalList = getObjects(Goal.class);
            for(Goal agoal: goalList)
            {
                agoal.reset();
            }
            
        }
        
    }


    /**
     * Prepare the world for the start of the program. That is: create the initial
     * objects and add them to the world.
     */
    private void prepare()
    {
        
        Images images = new Images(worldWidth, worldHeight, boundrySize);
        addObject(images, worldWidth/2, worldHeight/2);
       
        Score leftScore = new Score("Player 1");
        addObject(leftScore, 50, 12);
        
        Score rightScore = new Score("Player 2");
        addObject(rightScore, 980, 560);
        
        Goal rightgoal = new Goal("right",leftScore, worldWidth, worldHeight, boundrySize);
        addObject(rightgoal, ((worldWidth-boundrySize)+(9)), worldHeight/2);
        this.rightgoal = rightgoal;
       
        Goal leftgoal = new Goal("left",rightScore, worldWidth, worldHeight, boundrySize);
        addObject(leftgoal, boundrySize-10, worldHeight/2);
        this.leftgoal = leftgoal;
        
        
        paddle leftpaddle = new paddle(70, worldHeight/2, "w", "s");
        addObject(leftpaddle, 70, worldHeight/2);
         
        paddle rightpaddle = new paddle(70, worldHeight/2, "up", "down");
        addObject(rightpaddle, worldWidth- 70, worldHeight/2);
        
        IntroScreen intro = new IntroScreen();
        addObject(intro, worldWidth/2, worldHeight/2);
        
        Instructions ins = new Instructions();
        addObject(ins, 900, 565);
       
    }
    
    public int getWorldWidth()
    {
        return worldWidth;
    }
    
    public int getWorldHeight()
    {
        return worldHeight;
    }
    
    public int getBoundrySize()
    {
        return boundrySize;
    }
}
