import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Color;

/**
 * Write a description of class Goals here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Goal extends Actor
{
private int worldWidth;
private int worldHeight;
private int boundrySize;
private GreenfootImage actorImage;
private int goalWidth = 20;
private int goalHeight = 160;
private int circleDiameter = 150;
private String name;
private Score scoreboard;
    /**
     * Act - do whatever the Goals wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        // Add your action code here.
    }    
    
    public Goal(String name ,Score scoreboard, int worldWidth, int worldHeight, int boundrySize)
    {
        int x;
        
        this.name = name;
        this.scoreboard = scoreboard;
        this.worldWidth = worldWidth;
        this.worldHeight = worldHeight;
        this.boundrySize = boundrySize;
        actorImage = new GreenfootImage(goalWidth, goalHeight);
        if(name.equals("left")==true)
        {
            x = boundrySize - goalWidth;
            setRotation(0);
        }
        else
        {
            x = worldWidth - boundrySize;
            setRotation(180);  
        }
        
        drawGoal(name, goalWidth, goalHeight);
        setImage(actorImage);
    }
    
    
    public void drawGoal(int goalWidth, int goalHeight)
    {
      name = "";
      
      actorImage.setColor(new Color(0,0,0));
      actorImage.fillRect(0, 0, goalWidth , goalHeight);
    }
    
    public void drawGoal(String name, int goalWidth, int goalHeight)
    {
      this.name = name;
      actorImage.setColor(new Color(0,0,0));
      actorImage.fillRect(0, 0, goalWidth , goalHeight);
    }
    
    public void goalMade()
    {
        scoreboard.IncrementScore();
    }
    
    public void reset()
    {
        scoreboard.resetScore();
    }
}
