import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Color;
/**
 * Write a description of class Score here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Score extends Actor
{
private int numScores;
private GreenfootImage Display;
private String playername;
private Color transparent;
private GreenfootImage[] imageArray = {
    new GreenfootImage("player10.gif"), 
    new GreenfootImage("player11.gif"),
    new GreenfootImage("player12.gif"),
    new GreenfootImage("player20.gif"),
    new GreenfootImage("player21.gif"),
    new GreenfootImage("player22.gif")};

private static GreenfootSound win = new GreenfootSound("Win.wav"); 
int s = 0;
int g = 0;


public Score(String playername)
{
this.playername = playername;
transparent = new Color(0,0,0,0);
numScores = 0;
Display = new GreenfootImage(playername+": "+numScores, 20, Color.BLACK, transparent);
setImage(Display);

}
    /**
     * Act - do whatever the Score wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        Player1Victory();
        Player2Victory();
        animations();
        reset();
    }
    
    public void resetScore()
    {
        numScores = 0;
        Display.clear();
        Display = new GreenfootImage(playername+": "+numScores, 20, Color.BLACK, transparent);
        setImage(Display);
        
    }
    
    public void IncrementScore()
    {
        numScores++;
        Display.clear();
        Display = new GreenfootImage(playername+": "+numScores, 20, Color.BLACK, transparent);
        setImage(Display);
    }
    
    public void Player1Victory()
    {
        if(numScores > 4 && getX() < 520)
        {
            setImage(imageArray[0]);
            setLocation(520,300);
            
            
        }
        if(getImage() == imageArray[0])
        {
            g++;
        }
        if(g==40)
            {
              win.play();
            }
    }
    
    public void Player2Victory()
    {
        if(numScores>4 && getX() > 520)
        {
            setImage(imageArray[3]);
            setLocation(520,300);
        }
    }
    
    public void animations()
    {
        s++;
        if(getImage() == imageArray[0] && s > 90)
        {
            setImage(imageArray[1]);
        }
         if(getImage() == imageArray[1] && s > 180)
        {
            setImage(imageArray[2]);
        }
         if(getImage() == imageArray[2] && s > 500)
        {
            setImage(imageArray[0]);
            s = 0;
        }
        
        if(getImage() == imageArray[3] && s > 90)
        {
            setImage(imageArray[4]);
        }
         if(getImage() == imageArray[4] && s > 180)
        {
            setImage(imageArray[5]);
        }
         if(getImage() == imageArray[5] && s > 500)
        {
            setImage(imageArray[3]);
            s = 0;
        }
    }
    
    public void reset()
    {
        if(numScores > 4)
        {
            if(Greenfoot.mouseClicked(this))
            {
                Greenfoot.setWorld(new Board());   
            }
            if(Greenfoot.isKeyDown("space"))
            {
                Greenfoot.setWorld(new Board());
            }
        }
    }
}
